<div id="toc">
  <div class="toc-content">{{ .TableOfContents }}</div>
</div>

<script>
  document.addEventListener("scroll", (event) => {
    let toc = document.getElementById("toc");
    let headings = document.querySelectorAll(
      "site-main .content h1[id], h2[id], h3[id]"
    );

    headings.forEach((heading) => {
      let tocItem = document.querySelector(`a[href="#${heading.id}"]`.trim());
      if (!tocItem) {
        console.debug(
          `No TOC item found for heading`,
          heading,
          `a[href="#${heading.id}"]`
        );
        return;
      }
      tocItem.classList.remove("active");
    });

    for (let i = headings.length - 1; i >= 0; i--) {
      let tocItem = toc.querySelector(`a[href="#${headings[i].id}"]`);
      if (!tocItem) return;

      let pixelsThatTheHeadingIsAwayFromTheTopEdge =
        headings[i].getBoundingClientRect().top;
      if (pixelsThatTheHeadingIsAwayFromTheTopEdge <= 100) {
        tocItem.classList.add("active");
        return;
      }
    }
  });
</script>
